;ESB Installer Script


;--------------------------------
;Include Modern UI

  !include "MUI2.nsh"

;--------------------------------
;General

  ;Name and file
  Name "PServiceBus 3.0.0"
  OutFile "PServiceBusSetup.exe"

  ;Default installation folder
  InstallDir "$PROGRAMFILES\PServiceBus 3.0.0"
  
  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\PServiceBus 3.0.0" ""

  ;Request application privileges for Windows Vista
  RequestExecutionLevel user

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_LICENSE "license.txt"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections

Section "PServiceBus" SecDummy

  SetOutPath "$INSTDIR"
  
  File ESBSetup.exe
  
  File ESBSetup.exe.config
  
  File PSBReset.exe
  
  File PSBUtil.exe

  ExecWait '"$INSTDIR\ESBSetup.exe" uninstall cleanup'
  
  File /r "ESB"

  File /r "ESB WEB REST"
  
  File /r "ESB Router"
  
  File /r "ESB WebSocket"
  
  File /r "ESB WebSocket RPC"

  File /r "ESB Gateway"

  File /r "Redis Server"

  ExecWait '"$INSTDIR\ESBSetup.exe" install'

  ;Store installation folder
  WriteRegStr HKCU "Software\PServiceBus 3.0.0" "" $INSTDIR
  
  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

SectionEnd

;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_SecDummy ${LANG_ENGLISH} "This will install all the necessary components to host the ESB"

  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SecDummy} $(DESC_SecDummy)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Uninstaller Section

Section "Uninstall"

  ExecWait '"$INSTDIR\ESBSetup.exe" uninstall'

  Delete "$INSTDIR\Uninstall.exe"

  RMDir /r "$INSTDIR"

  DeleteRegKey /ifempty HKCU "Software\PServiceBus 3.0.0"

SectionEnd