﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using PServiceBus.Core.Interface;
using Phoenix.ReflectionExtensions;
using PServiceBus.Core.Runtime;
using PServiceBus.Core.Logger;

namespace PServiceBus.Core.Configuration {
    internal class TopicMessageInspectorElement : ConfigurationElement, PServiceBus.Core.Interface.ITopicMessageInspectorConfig {
        public TopicMessageInspectorElement() { }
        public TopicMessageInspectorElement(string name) { Name = name; }
        [ConfigurationProperty("name", IsRequired = true, IsKey = true)]
        public string Name {
            get { return base["name"] as string; }
            set { base["name"] = value; }
        }
        [ConfigurationProperty("type", IsRequired = true)]
        public string Type {
            get { return base["type"] as string; }
            set { base["type"] = value; }
        }
    }
    [ConfigurationCollection(typeof(TopicMessageInspectorElement), CollectionType = ConfigurationElementCollectionType.BasicMap)]
    internal sealed class TopicMessageInspectorCollection : ConfigurationElementCollection {
        protected override ConfigurationElement CreateNewElement() {
            return new TopicMessageInspectorElement();
        }

        protected override object GetElementKey(ConfigurationElement element) {
            return (element as TopicMessageInspectorElement).Name;
        }
    }
    public sealed class TopicMessageInspectorConfigSection : ConfigurationSection {
        [ConfigurationProperty("inspectors", IsDefaultCollection = true, IsRequired = true)]
        internal TopicMessageInspectorCollection Inspectors {
            get { return this["inspectors"] as TopicMessageInspectorCollection; }
        }
    }
}
