﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PServiceBus.Core.Interface {
    public interface IComponentContainerConfig {
        /// <summary>
        /// Gets or sets the batch size.
        /// </summary>
        /// <value>The size of the batch.</value>
        int BatchSize { get; set; }
        /// <summary>
        /// Gets or sets the interval to wait for before getting the next batch.
        /// </summary>
        /// <value>The interval.</value>
        int Interval { get; set; }
        /// <summary>
        /// Gets or sets the address for data store used in component.
        /// </summary>
        /// <value>The address.</value>
        string Address { get; set; }
        /// <summary>
        /// Gets or sets the address unique id.
        /// </summary>
        /// <value>The address id.</value>
        string AddressID { get; set; }
    }
}
