﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PServiceBus.Core.Interface {
    /// <summary>
    /// Configuration for setting up message distributor
    /// </summary>
    public interface IDistributorConfig {
        /// <summary>
        /// Gets or sets a value indicating whether distributor is enabled.
        /// </summary>
        /// <value><c>true</c> if enabled; otherwise, <c>false</c>.</value>
        bool Enabled { get; set; }
        /// <summary>
        /// Gets or sets the address for storing message that would be distributed by the distributor.
        /// </summary>
        /// <value>The address.</value>
        string Address { get; set; }
        /// <summary>
        /// Gets or sets the address id to uniquely identify distributor.
        /// </summary>
        /// <value>The address id.</value>
        string AddressID { get; set; }
        /// <summary>
        /// Gets or sets the component service info address
        /// </summary>
        /// <value>The component service info address.</value>
        string ComponentServiceInfoAddress { get; set; }
    }
}
