﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PServiceBus.Core.Interface {
    /// <summary>
    /// Configuration for defining how logging should work
    /// </summary>
    public interface ILoggerConfig {
        /// <summary>
        /// Gets or sets the logger type to use for general logging ex. ConsoleLogger, EventLogLogger, e.t.c.
        /// </summary>
        /// <value>The type.</value>
        string Type { get; set; }
        /// <summary>
        /// Gets or sets the trace path to write trace information.
        /// </summary>
        /// <value>The trace path.</value>
        string TracePath { get; set; }
        /// <summary>
        /// Gets or sets the error log path to write caught exceptions.
        /// </summary>
        /// <value>The error log path.</value>
        string ErrorLogPath { get; set; }
        /// <summary>
        /// Gets or sets the log path to store basic logging information such [initialing system].
        /// </summary>
        /// <value>The log path.</value>
        string LogPath { get; set; }
        /// <summary>
        /// Gets or sets a value indicating whether logging is enabled.
        /// </summary>
        /// <value><c>true</c> if enabled; otherwise, <c>false</c>.</value>
        bool Enabled { get; set; }
    }
}
