﻿using System;
namespace PServiceBus.Core.Interface {
    /// <summary>
    /// Implemented by ITopicObserver and ISubscriberObserver
    /// </summary>
    public interface IObserver {
        /// <summary>
        /// Address to observe
        /// </summary>
        string Address { get; set; }
        /// <summary>
        ///  Interval in millisecond/second?
        /// </summary>
        int Interval { get; set; }
        /// <summary>
        /// Stop observing
        /// </summary>
        void Stop();
        /// <summary>
        /// Startup code
        /// </summary>
        void Init();
        /// <summary>
        /// Start observing
        /// </summary>
        void Start();
    }
}
