﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PServiceBus.Core.Runtime.Messages;

namespace PServiceBus.Core.Interface {
    /// <summary>
    /// Implement this interface if you want to intercept every message in order to enrich them
    /// </summary>
    public interface ITopicMessageEnricher {
        /// <summary>
        /// Implementer should write logic that will modify the content of the message before it is send to the distributor if any exists
        /// </summary>
        /// <param name="message"></param>
        void Enrich(ref TopicMessage message);
    }
}
