﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PServiceBus.Core.Runtime.Messages;

namespace PServiceBus.Core.Interface {
    /// <summary>
    /// Implement this interface if you want to validate the content of every message that will be sent
    /// </summary>
    public interface ITopicMessageInspector {
        /// <summary>
        /// Implementer should write logic to validate the content of message and if invalid should throw any necessary exception that is needed
        /// </summary>
        /// <param name="message"></param>
        void Verify(TopicMessage message);
    }
}
