﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Phoenix.Installer;
using System.Xml;
using PServiceBus.Core.Runtime.Configuration;

namespace PServiceBus.Endpoints.WebAPI {
    public class ServiceInstaller : IServiceInstaller {
        #region IServiceInstaller Members

        public IEnumerable<ServiceInstallerInfo> Services {
            get {
                return ConfigurationParser.Process("services.xml")
                    .Select(x => x["service"] as Dictionary<string, object>)
                    .Select(x => x.ToDictionary(kv => kv.Key, kv => kv.Value == null ? string.Empty : kv.Value.ToString()))
                    .Select(element => new ServiceInstallerInfo()
                    {
                        Name = element["id"],
                        Description = "REST Web Service for communicating with ESB through HTTP/HTTPS",
                        DependOn = element.ContainsKey("dependon") ? element["dependon"] : string.Empty,
                        ExeFileName = "PServiceBus.Endpoints.WebAPI.exe"
                    });
            }
        }

        #endregion
    }
}
