﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PServiceBus.Core.Interface;
using PServiceBus.Core.Security;
using PServiceBus.Gateway.Interfaces.DTO;

namespace PServiceBus.Gateway.Interfaces {
    public interface IMessageBus : IDisposable {
        void CreateSubscriber(string subscriber);
        void ChangeSubscriberDurability(string subscriber, bool durable);
        void SubscribeTo(string subscriber, string topicName, string filter, bool needHeader, bool caseSensitive);
        void UpdateSubscriber(string subscriber, string topicName, string filter, bool needHeader, bool caseSensitive);
        void UnSubscribeFrom(string subscriber, string topicName);
        void AddTransport(string subscriber, string transportName, ITransport transport, string topicName);
        void DeleteTransport(string subscriber, string transportName);
        SubscriberInfo SelectSubscriber(string name);
        TopicInfo SelectTopic(string name);
        void DeleteSubscriber(string name);
        void RegisterTopic(TopicInfo topic);
        void PublishTopic(TopicInfo topic);
        void DeleteTopic(string name);
        IList<TopicInfo> GetTopics();
        bool IsClosed { get; }
        bool ReThrowException { get; set; }
        ESBIdentity Identity { get; set; }
        Dictionary<string, string> Headers { get; set; }
    }
}
