﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using PServiceBus.Gateway.Interfaces.Commands;
using Phoenix.RedisConnectors;

namespace PServiceBus.Gateway.Redis.Commands {

    public sealed class RedisRouterMessage : RouterMessage, IRedisCommand {
        #region IRedisCommand Members

        public bool IsAsync { get; set; }

        public string Key { get; set; }

        public RedisPatternType Pattern { get; set; }

        public string CommandID { get; set; }

        #endregion

        public static RedisRouterMessage New(Guid? id = null, bool decrement = false, bool async = true) {
            var stack = new StackTrace(false);
            var commandName = stack.GetFrame(1).GetMethod().Name;
            return new RedisRouterMessage()
            {
                ID = id ?? Guid.Empty,
                Decrement = decrement,
                CommandName = commandName,
                IsAsync = async
            };
        }
    }
}
