﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PServiceBus.Core.Security;
using PServiceBus.Gateway.Interfaces;
using PServiceBus.Gateway.Interfaces.DTO;
using Phoenix.ZeroMQConnectors;

namespace PServiceBus.Gateway.ZeroMQ.DTO {
    public class ZeroMQESBRequest : ESBRequest, IZeroMQCommand {

        #region IZeroMQCommand Members

        public bool IsAsync { get; set; }

        public string Key { get; set; }

        public ZeroPatternType Pattern { get; set; }

        #endregion
        public static ZeroMQESBRequest New(string input = "", ESBIdentity userIdentity = null, bool reThrowException = false, Dictionary<string, string> headers = null) {
            var identity = userIdentity ?? ESBPrincipal.Current.ESBIdentity;
            return new ZeroMQESBRequest()
            {
                Input = input,
                UserContext = new ESBUserContext() {
                    UserName = identity.Name,
                    Password = identity.Password
                }, ReThrowException = reThrowException,
                Headers = headers
            };
        }
        public static ZeroMQESBRequest Empty {
            get { return New(string.Empty); }
        }
    }
}
