﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using PServiceBus.Core.Runtime;

namespace PServiceBus.Tests.Unit {
    [TestClass]
    public class ExpressionGeneratorTest {
        
        [TestMethod]
        public void ExpressionWithTwoConditionShouldReturnTrue() {
            var expression = ExpressionGenerator.Build("test1    =a && test2 = a ");
            Assert.IsTrue((bool)expression.DynamicInvoke("a", "a"), "test1 = a should be true, test2 = a should be true");
        }

        [TestMethod]
        public void TestGuidComparison() {
            var guid = new Guid("00000000-0000-0000-0000-000000000000");
            var expression = ExpressionGenerator.Build("SessionID=54779b3a-870d-400b-bb89-10c4f91004be");
            Assert.IsTrue(expression(guid.ToString()));
        }

        [TestMethod]
        public void TestThatRepeatedConditionIsNotFalse() {
            var expressionText = "Test1 = \"19A03736-CAFB-40CE-A3CF-E64CF7AFB7D7\"";
            var expression = ExpressionGenerator.Build(expressionText);
            var result = (bool)expression.DynamicInvoke("19A03736-CAFB-40CE-A3CF-E64CF7AFB7D7");
            //var test1Is2 = expression("Test1", "2");
            //Assert.IsTrue(count == 2, "Count should be 1");
            Assert.IsTrue(result, "Test1 should equal true");
            //Assert.IsTrue(test1Is2, "Test1 should equal 2");
        }

        [TestMethod]
        public void TestThatConditionIsNotTrueAndIsTrue() {
            var exp = "UserName != \"Olamide\" || UserName = \"TM\" || Message = \"Test\"";
            var expression = ExpressionGenerator.Build(exp);
            var isNotOlamideIsTrue = (bool)expression.DynamicInvoke("Test", "TM");
            var isNotOlamideIsFalse = (bool)expression.DynamicInvoke("Tester", "Olamide");
            Assert.IsTrue(isNotOlamideIsTrue);
            Assert.IsFalse(isNotOlamideIsFalse);
        }
    }
}
