﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PServiceBus.Core.Interface;
using PServiceBus.Core.Runtime.Messages;

namespace PServiceBus.Transports.Handlers {
    public sealed class MSMQTransportHandler : ITransportHandler<MSMQTransport> {
        #region ITransportHandler<MSMQTransport> Members

        public IMessageHandler<TMessage> CreateHandler<TMessage>(MSMQTransport transport) where TMessage : class {
            return MessageHandlerBase<TMessage, string>.New<MSMQTransport>(this, new MSMQ.Provider<string>(), () => transport.Path);
        }

        public TimeSpan Interval { get; set; }

        public int BatchSize { get; set; }

        #endregion
    }
}
