﻿using System;
using PServiceBus.Core.Interface;
using PServiceBus.Core.Runtime;
using PServiceBus.Core.Provider;
using PServiceBus.Core.Runtime.Transports;
using PServiceBus.MSMQ;
using System.Runtime.Serialization;
using System.ComponentModel.Composition;
using System.Collections.Generic;

namespace PServiceBus.Transports {
    [Serializable]
    [DataContract]
    [Export(typeof(ITransport))]
    public class MSMQTransport : ITransport, IDeletableTransport {

        [DataMember]
        public string Path { get; set; }

        #region ITransport Members
        [DataMember]
        public TransportFormat Format { get; set; }

        public TransportResponse Send(string message, Dictionary<string, object> messageStructure) {
            var tranResponse = TransportResponse.New<MSMQTransport>();
            try {
                Provider<string>.GetProvider(Path).Add(message);
                tranResponse.Success = true;
            } catch (Exception ex) {
                tranResponse.Message = ex.ToString();
            }
            return tranResponse;
        }
        #endregion

        #region IDeletableTransport Members

        void IDeletableTransport.Delete() {
            Provider<string>.GetProvider(Path).Delete();
        }

        #endregion
    }
}
